package com.rjconsultores.ventaboletos.service.impl;

import java.util.Calendar;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.rjconsultores.ventaboletos.dao.CaixaContratoDAO;
import com.rjconsultores.ventaboletos.entidad.CaixaContrato;
import com.rjconsultores.ventaboletos.service.CaixaContratoService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;


@Service("caixaContratoService")
public class CaixaContratoServiceImpl implements CaixaContratoService {

    @Autowired
    private CaixaContratoDAO caixaContratoDAO;

    public CaixaContrato obtenerID(Long id) {
        return caixaContratoDAO.obtenerID(id);
    }

    @Transactional
    public CaixaContrato suscribir(CaixaContrato entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecModif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return caixaContratoDAO.suscribir(entidad);
    }

	@Override
	public List<CaixaContrato> obtenerTodos() {
        return caixaContratoDAO.obtenerTodos();
    }

	@Override
	public CaixaContrato actualizacion(CaixaContrato entidad) {
		throw new RuntimeException("Esse componente não implementa esse metodo");
	}

	@Override
	public void borrar(CaixaContrato entidad) {
		throw new RuntimeException("Esse componente não implementa esse metodo");	
	}

	@Override
	public List<CaixaContrato> buscarExtratoContrato(Long contratoId) {
		return caixaContratoDAO.buscarExtratoContrato(contratoId);
	}

	@Override
	@Transactional
	public CaixaContrato gravarMovimento(CaixaContrato caixa) {
		return caixaContratoDAO.gravarMovimento(caixa);
	}
}
